#include <cstdio>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std  ;

int main(int argc, char* argv[]) {
    ifstream fin ;
    int N , M , P ;  // N - row , M - column ,  P  - number animals
    char ch ;   // work
    int i , j , m , n ;  // work

    fin.open ( "parash.in",ios::in) ;
    if ( !fin.is_open()) {
        cout << "cant find parash.in" << endl ;
        return 1 ;
    }

    fin >> N ; fin >> M ; fin >> P ;

    //  int Field [N][M] ;  for best time

    // input data field
    int **Field = new int*[N];
    int **SaveField = new int*[N];
    for ( i = 0 ; i < N  ; i++ )
          Field[i] = new int[M] ;
    for ( i = 0 ; i < N  ; i++ )
          SaveField[i] = new int[M] ;


    for ( i = 0 ; i < N ; i++ )
        for ( j = 0 ; j < M ; j++ )
          fin >> SaveField[i][j] ;

    // end input data filed


    // input data animal
    int ***Animal_place = new int**[P] ;
    int **Animal = new int*[P]  ;
    for ( i = 0 ; i < P  ; i++ )
       Animal[i] = new int[5] ;  // 0 - row , 1 - column  , 2 - coef , 3 -  low limit , 4 - used / unused 1 , 0

    int **Decision1 = new int*[P] ;
    for ( i = 0 ; i < P  ; i++ )
       Decision1[i] = new int[3] ;  // 0 = number animal + 1  , 1 -  X  + 1 coord  , 2 - Y + 1 coord


    int **Decision2 = new int*[P] ;
    for ( i = 0 ; i < P  ; i++ )
       Decision2[i] = new int[3] ;  // 0 = number animal + 1  , 1 -  X  + 1 coord  , 2 - Y + 1 coord


    int **Decision3 = new int*[P] ;
    for ( i = 0 ; i < P  ; i++ )
       Decision3[i] = new int[3] ;  // 0 = number animal + 1  , 1 -  X  + 1 coord  , 2 - Y + 1 coord



    for ( i = 0 ; i < P ; i++ ) {
        fin >> Animal[i][0] >> Animal[i][1] >>  Animal[i][2] >> Animal[i][3] ;
        Animal[i][4] = 0 ;  // unused
        Animal_place[i] = new int*[Animal[i][0]];
        for ( j=0 ; j < Animal[i][0] ; j++ )
           Animal_place[i][j] = new int[Animal[i][1]] ;
        for (   n = 0 ; n < Animal[i][0] ; n++)
           for (   m = 0 ; m < Animal[i][1]; m++) {
              fin >> ch ;
              Animal_place[i][n][m]  = int (ch - '0');
           }

     }
     // end data animal
     fin.close() ;


     // ENGINE  BEGIN
     int TmpMax , Max , TmpMaxCover , MaxCover , Min   ;
     int Suma1 = 0 , Suma2 = 0  , Suma3 = 0 ;
     int NUMBER1 = 0 , NUMBER2 = 0 , NUMBER3 = 0 ;
     int A , X , Y ;
     int x , y , flag_coef , flag_decision; // relative local coordinate



    for ( i = 0 ; i < N ; i++ )
        for ( j = 0 ; j < M ; j++ )
          Field[i][j] = SaveField[i][j] ;
    for ( i = 0 ; i < P ; i++ )  Animal[i][4] = 0 ;
     while (1) {  // begin 1
     flag_decision = 0 ; Max = 0 ;
     for ( i = 0 ; i < P ; ++i ) {
        if ( Animal[i][4]  == 1 ) continue ; // used
        for ( n = 0 ; n < N ; n++) {
            if ( n + Animal[i][0] > N )  continue ;  // out limits field
            for ( m = 0 ; m < M ; m++ ) {
                if ( m + Animal[i][1] > M )  continue ;  // out limits  field
                flag_coef = 0 ; TmpMax = 0 ;
                for (x = 0 ; x < Animal[i][0] ; x++) {
                    if ( flag_coef ) break ;
                    for (y = 0 ; y < Animal[i][1] ; y++ ) {
                      if ( Animal_place[i][x][y] ) {   // != 0 , contact
                        if ( Field [n+x][m+y] < Animal[i][3] )  { // check  limits coeficent
                         flag_coef = 1 ;
                         break ;
                        }
                        TmpMax = TmpMax +  Field [n+x][m+y] ;
                      }
                    }  // end for y
                }   // end for x

                if ( flag_coef )  continue ;
                if ( TmpMax > Max ) {
                     X = n ;      // coordina x
                     Y = m ;      // coordina y
                     A = i ; // number of animal
                     Max = TmpMax ;
                     flag_decision = 1 ;
                }

            }   // end of for m

        }   // end of for n
     }  // end of for i
     if ( flag_decision ) {  // there is decision
       // compute field
       for ( x = 0 ; x < Animal[A][0]; x++ )
         for ( y = 0 ; y < Animal[A][1]; y++ )
            if ( Animal_place[A][x][y])
                Field[X+x][Y+y] = Field[X+x][Y+y] / Animal[A][2] ;
       Animal[A][4] = 1 ;

       Decision1[NUMBER1][0] = A + 1 ;
       Decision1[NUMBER1][1] = X + 1 ;
       Decision1[NUMBER1][2] = Y + 1 ;
       ++NUMBER1 ;
       Suma1 = Suma1 + Max ;
     }
      else break ;  // end of game
     } // end of while of 1



    for ( i = 0 ; i < N ; i++ )
        for ( j = 0 ; j < M ; j++ )
          Field[i][j] = SaveField[i][j] ;
    for ( i = 0 ; i < P ; i++ )  Animal[i][4] = 0 ;
     while (1) {  // begin 2
     flag_decision = 0 ; Max = 0 ; MaxCover = 0 ;
     for ( i = 0 ; i < P ; ++i ) {
        if ( Animal[i][4]  == 1 ) continue ; // used
        for ( n = 0 ; n < N ; n++) {
            if ( n + Animal[i][0] > N )  continue ;  // out limits field
            for ( m = 0 ; m < M ; m++ ) {
                if ( m + Animal[i][1] > M )  continue ;  // out limits  field
                flag_coef = 0 ; TmpMax = 0 ; TmpMaxCover = 0 ;
                for (x = 0 ; x < Animal[i][0] ; x++) {
                    if ( flag_coef ) break ;
                    for (y = 0 ; y < Animal[i][1] ; y++ ) {
                      if ( Animal_place[i][x][y] ) {   // != 0 , contact
                        if ( Field [n+x][m+y] < Animal[i][3] )  { // check  limits coeficent
                         flag_coef = 1 ;
                         break ;
                        }
                        TmpMax = TmpMax +  Field [n+x][m+y] ;
                        TmpMaxCover = TmpMaxCover +  1 ;
                      }
                    }  // end for y
                }   // end for x

                if ( flag_coef || MaxCover > TmpMaxCover)  continue ;
                if ( MaxCover < TmpMaxCover ) { // swap
                    MaxCover = TmpMaxCover ;
                    X = n ;      // coordina x
                    Y = m ;      // coordina y
                    A = i ; // number of animal
                    flag_decision = 1 ;
                    Max = TmpMax ;
                    continue ;
                }

                if ( TmpMax > Max ) {
                     X = n ;      // coordina x
                     Y = m ;      // coordina y
                     A = i ; // number of animal
                     Max = TmpMax ;
                     flag_decision = 1 ;

                }

            }   // end of for m

        }   // end of for n
     }  // end of for i
     if ( flag_decision ) {  // there is decision
       // compute field
       for ( x = 0 ; x < Animal[A][0]; x++ )
         for ( y = 0 ; y < Animal[A][1]; y++ )
            if ( Animal_place[A][x][y])
                Field[X+x][Y+y] = Field[X+x][Y+y] / Animal[A][2] ;
       Animal[A][4] = 1 ;

       Decision2[NUMBER2][0] = A + 1 ;
       Decision2[NUMBER2][1] = X + 1 ;
       Decision2[NUMBER2][2] = Y + 1 ;
       ++NUMBER2 ;
       Suma2 = Suma2 + Max ;
     }
      else break ;  // end of game
     } // end of while of 2



    for ( i = 0 ; i < N ; i++ )
        for ( j = 0 ; j < M ; j++ )
          Field[i][j] = SaveField[i][j] ;
    for ( i = 0 ; i < P ; i++ )  Animal[i][4] = 0 ;
     while (1) {  // begin 3
     flag_decision = 0 ; Max = 0 ; MaxCover = 0 ;  Min = 1000000 ;
     for ( i = 0 ; i < P ; ++i ) {
        if ( Animal[i][4]  == 1 ) continue ; // used
        for ( n = 0 ; n < N ; n++) {
            if ( n + Animal[i][0] > N )  continue ;  // out limits field
            for ( m = 0 ; m < M ; m++ ) {
                if ( m + Animal[i][1] > M )  continue ;  // out limits  field
                flag_coef = 0 ; TmpMax = 0 ; TmpMaxCover = 0 ;
                for (x = 0 ; x < Animal[i][0] ; x++) {
                    if ( flag_coef ) break ;
                    for (y = 0 ; y < Animal[i][1] ; y++ ) {
                      if ( Animal_place[i][x][y] ) {   // != 0 , contact
                        if ( Field [n+x][m+y] < Animal[i][3] )  { // check  limits coeficent
                         flag_coef = 1 ;
                         break ;
                        }
                        TmpMax = TmpMax +  Field [n+x][m+y] ;
                        TmpMaxCover = TmpMaxCover +  1 ;
                      }
                    }  // end for y
                }   // end for x

                if ( flag_coef || MaxCover > TmpMaxCover)  continue ;
                if ( MaxCover < TmpMaxCover ) { // swap
                    MaxCover = TmpMaxCover ;
                    X = n ;      // coordina x
                    Y = m ;      // coordina y
                    A = i ; // number of animal
                    flag_decision = 1 ;
                    Max = TmpMax ;
                    Min = Animal[i][2] ;
                    continue ;
                }

                if (  Min > Animal[i][2]  ) {
                    X = n ;      // coordina x
                    Y = m ;      // coordina y
                    A = i ; // number of animal
                    Max = TmpMax ;
                    Min = Animal[i][2] ;
                    flag_decision = 1 ;
                    continue ;
                }

                if ( TmpMax > Max && Min == Animal[i][2]  ) {
                     X = n ;      // coordina x
                     Y = m ;      // coordina y
                     A = i ; // number of animal
                     Max = TmpMax ;
                     flag_decision = 1 ;
                }

            }   // end of for m

        }   // end of for n
     }  // end of for i
     if ( flag_decision ) {  // there is decision
       // compute field
       for ( x = 0 ; x < Animal[A][0]; x++ )
         for ( y = 0 ; y < Animal[A][1]; y++ )
            if ( Animal_place[A][x][y])
                Field[X+x][Y+y] = Field[X+x][Y+y] / Animal[A][2] ;
       Animal[A][4] = 1 ;

       Decision3[NUMBER3][0] = A + 1 ;
       Decision3[NUMBER3][1] = X + 1 ;
       Decision3[NUMBER3][2] = Y + 1 ;
       ++NUMBER3 ;
       Suma3 = Suma3 + Max ;
     }
      else break ;  // end of game
     } // end of while of 3


     //  ENGINE END

     // write parash.out
     ofstream fout ;
     fout.open("parash.out",ios::out) ;
     if ( !fout.is_open()) {
        cout << "cant create parash.out" << endl ;
        return 1 ;
    }



      if ( Suma2 >= Suma1 && Suma2 >= Suma3 ) {
        fout << NUMBER2 << endl ;
        for ( i = 0 ; i  < NUMBER2 ; i++)
            fout << Decision2[i][0] << " " << Decision2[i][1] << " " <<Decision2[i][2] << endl ;
      }
      else
        if (Suma1 >= Suma2 && Suma1 >= Suma3) {
          fout << NUMBER1 << endl ;
          for ( i = 0 ; i  < NUMBER1 ; i++)
            fout << Decision1[i][0] << " " << Decision1[i][1] << " " <<Decision1[i][2] << endl ;
        }
        else
         if (Suma3 >= Suma2 && Suma3 >= Suma1) {
          fout << NUMBER3 << endl ;
          for ( i = 0 ; i  < NUMBER3 ; i++)
            fout << Decision3[i][0] << " " << Decision3[i][1] << " " <<Decision3[i][2] << endl ;
        }

        fout.close() ;

/*
    cout << "Suma1 " << Suma1 << " NUMBER1 " << NUMBER1 << endl ;
    cout << "Suma2 " << Suma2 << " NUMBER2 " << NUMBER2 << endl ;
    cout << "Suma3 " << Suma3 << " NUMBER3 " << NUMBER3 << endl ;
    cout << "M " << M << " N " << N << " P " << P << endl ;
*/
/*
    //control print
    cout << setfill(' ') ;
    cout << N <<  setw(3) << M << setw(3) << P << endl ;

     //control print   filed
     for (  i = 0 ; i < N ; i++ ) {
        for (  j = 0 ; j < M ; j++ )
          cout << Field[i][j] << setw(4) ;
        cout << setw(0) << endl  ;
    }

    // control print animal
    for (  i = 0 ; i < P ; i++ ) {
        cout <<  Animal[i][0] << setw(3) << Animal[i][1] << setw(3) <<   Animal[i][2] <<  setw(3) << Animal[i][3] <<  setw(3) << Animal[i][4]  << endl;
        for (  n = 0 ; n < Animal[i][0] ; n++) {
           for (  m = 0 ; m < Animal[i][1]; m++)
              cout << Animal_place[i][n][m] << setw(2) ;
           cout << setw(0) << endl ;
        }
     }
*/

     // free memory
    for (  i = 0 ; i < N  ; i++ )
          delete [] Field[i] ;
    delete [] Field ;

    for (  i = 0 ; i < N  ; i++ )
          delete [] SaveField[i] ;
    delete [] SaveField ;



    for (  i = 0 ; i < P  ; i++ )
          delete [] Decision1[i] ;
    delete [] Decision1 ;


    for (  i = 0 ; i < P  ; i++ )
          delete [] Decision2[i] ;
    delete [] Decision2 ;


    for (  i = 0 ; i < P  ; i++ )
          delete [] Decision3[i] ;
    delete [] Decision3 ;



    for (  i = 0 ; i < P ; i++ ) {
        for ( j=0 ; j < Animal[i][0] ; j++ )
          delete []   Animal_place[i][j] ;
        delete []  Animal_place[i] ;
    }
    delete [] Animal_place ;

    for (  i = 0 ; i < P  ; i++ )
          delete [] Animal[i] ;
    delete [] Animal ;

  	return 0;
}
